DISPLEJ	MACRO	TMH,TML,DDATA,PO4,P4,PO5,P5,PO6,P6,PO7,P7,POE,PE,PORW,PRW,PORS,PRS
; sbirka zakladnich obsluznych rutin pro displej s radicem HD44780

; TMH,TML a DDATA jsou pracovni promenne
; (PO4,P4),(PO5,P5) a dalsi jsou definice portu a pinu pro nasledujici vodice:...
;     ...DB4,DB5,DB6,DB7,E,RW,RS

	LOCAL	DOUT4,DOUT8,WAIT_BF		; tato navesti jsou zvenka neviditelna

; Primitivni zpozdovaci rutina
; - ve W musi byt delka zpozdeni (1 znamena asi 770 cyklu a 0 znamena maximum, tedy asi 256*770 cyklu)
DDELAY	MOVWF	TMH
	CLRF	TML
	DECFSZ	TML,F
	GOTO	$ - 1
	DECFSZ	TMH,F
	GOTO	$ - 3
	RETURN

;---------------------------------------------
;||||||||||  OBSLUHA DISPLEJE  |||||||||||||||
;---------------------------------------------

; Inicializace displeje
; - bez parametru
INITDISP	BSF	STATUS,RP0	; nastaveni banky 1 (pristup k TRIS registrum)
	BCF	PO4,P4		; vybrane piny nastavime jako vystup
	BCF	PO5,P5
	BCF	PO6,P6
	BCF	PO7,P7
	BCF	POE,PE
	BCF	PORW,PRW
	BCF	PORS,PRS
	BCF	STATUS,RP0	; nastaveni banky 0 (pristup k PORT registrum)
	BCF	PORS,PRS		; logicka nula na RS a WR
	BCF	PORW,PRW
	MOVLW	D'255'		; dlouha prodleva
	CALL	DDELAY
	CALL	DDELAY
	CALL	DDELAY
	CALL	DDELAY
	MOVLW	B'00110000'	; dale probiha jen inicializacni posloupnost...
	CALL	DOUT4
	MOVLW	D'97'
	CALL	DDELAY
	MOVLW	B'00110000'
	CALL	DOUT4
	MOVLW	D'3'
	CALL	DDELAY
	MOVLW	B'00110000'
	CALL	DOUT4
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00100000'
	CALL	DOUT4
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00101000'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00001000'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00001100'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00000001'
	CALL	DOUT8
	MOVLW	D'40'
	CALL	DDELAY
	MOVLW	B'00000110'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	RETURN

; 4 bity na vystup
; (elementarni interni rutina)
DOUT4	MOVWF	DDATA	; pracovni promenna
	BSF	POE,PE	; logicka 1 na E
	BCF	PO4,P4	; nastaveni pinu DB4 (podle DDATA)
	BTFSC	DDATA,4
	BSF	PO4,P4
	BCF	PO5,P5	; nastaveni pinu DB5
	BTFSC	DDATA,5
	BSF	PO5,P5
	BCF	PO6,P6	; nastaveni pinu DB6
	BTFSC	DDATA,6
	BSF	PO6,P6
	BCF	PO7,P7	; nastaveni pinu DB7
	BTFSC	DDATA,7
	BSF	PO7,P7
	BCF	POE,PE	; povoleni prenosu slova do radice
	RETURN

; 8 bitu na vystup
; (interni rutina)
DOUT8	MOVWF	DDATA	; pracovni promena
	BSF	POE,PE
	BCF	PO4,P4	; definuje se vyssi cast bytu
	BTFSC	DDATA,4
	BSF	PO4,P4
	BCF	PO5,P5
	BTFSC	DDATA,5
	BSF	PO5,P5
	BCF	PO6,P6
	BTFSC	DDATA,6
	BSF	PO6,P6
	BCF	PO7,P7
	BTFSC	DDATA,7
	BSF	PO7,P7
	BCF	POE,PE	; posila se vyssi cast slova
	BCF	PO4,P4	; ...a pripravuje se nizzi cast bytu
	BTFSC	DDATA,0
	BSF	PO4,P4
	BCF	PO5,P5
	BTFSC	DDATA,1
	BSF	PO5,P5
	BSF	POE,PE	; pripravuje se nabeh na pinu E
	BCF	PO6,P6	; ...pokracuje priprava nizzsi casti bytu
	BTFSC	DDATA,2
	BSF	PO6,P6
	BCF	PO7,P7
	BTFSC	DDATA,3
	BSF	PO7,P7
	BCF	POE,PE	; posila se nizzi cast bytu
	RETURN

; cekani na radic displeje (kontrola BF)
; (interni rutina, ktera neovlivnuje stav pracovniho registru W!!)
WAIT_BF	BCF	PORS,PRS		;  nastaveni RS vodice
	BSF	STATUS,RP0
	BSF	PO4,P4		; DB4,DB5,DB6,DB7 se nastavi jako vstup
	BSF	PO5,P5
	BSF	PO6,P6
	BSF	PO7,P7
	BCF	STATUS,RP0
	BSF	PORW,PRW		; rezim cteni z radice displeje
	BSF	POE,PE		; pokyn k vystaveni dat (vyssi cast bytu)
	NOP
	NOP
	BCF	DDATA,7		; precteni bitu BF a ulozeni do DDATA,7
	BTFSC	PO7,P7
	BSF	DDATA,7
	BCF	POE,PE
	NOP
	NOP
	BSF	POE,PE		; cteni druhe poploviny bytu
	NOP
	NOP
	BCF	POE,PE
	NOP
	NOP
	BTFSC	DDATA,7		; pokud je v DDATA,7 (v BF) jednicka, potom to cele zopakujeme
	GOTO	WAIT_BF
	BSF	STATUS,RP0	; nastavime vyvody jako vystupy
	BCF	PO4,P4
	BCF	PO5,P5
	BCF	PO6,P6
	BCF	PO7,P7
	BCF	STATUS,RP0
	BCF	PORW,PRW		; ukoncime cteci rezim
	RETURN

; reset displeje (vymazani obsahu a nastaveni na zacatek)
; - bez parametru
DISPRESET	MOVLW	B'00000001'	; definice prikazu RESET
	CALL	WAIT_BF		; cekani na uvolneni radice
	BCF	PORS,PRS		; prikazova oblast
	CALL	DOUT8		; poslani bytu na radic
	RETURN

; vypsani znaku
; - ve W musi byt ulozen kod znaku
PUTZNAK	CALL	WAIT_BF
	BSF	PORS,PRS		; datova oblast
	CALL	DOUT8
	RETURN

; univerzalni prikaz
; - ve W musi byt ulozen kod prikazu
DPRIKAZ	CALL	WAIT_BF
	BCF	PORS,PRS		; prikazova oblast
	CALL	DOUT8
	RETURN

; nastaveni polohy na displeji
; - ve W musi byt pozadovana poloha
SETPOS	IORLW	B'10000000'	; nejvyssi bit musi byt jednicka
	CALL	WAIT_BF
	BCF	PORS,PRS		; prikazova oblast
	CALL	DOUT8
	RETURN

; nastaveni SG-adresy (uzivatelske znaky)
; - ve W musi byt pozadovana SG adresa
SETSGPOS	ANDLW	B'00111111'	; nejvyssi bit musi byt nula
	IORLW	B'01000000'	; druhy nejvyssi bit musi byt jednicka
	CALL	WAIT_BF
	BCF	PORS,PRS		; prikazova oblast
	CALL	DOUT8
	RETURN

	ENDM
