;-----------------------------------------;
;    TENTO PROGRAM DEMONSTRUJE MOZNOST    ;
;     KONSTRUKCE VICEUROVNOVYCH MENU      ;
;      POMOCI ZOBRAZOVACICH SKRIPTU       ;
;-----------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	displej.inc
	#include	tab_util.inc
	#include	diakrit.inc
	#include	dskripty.inc
	#include	div16u.inc
	#include	key_sys.inc
	#include	menu.inc

; prirazeni spravnych kodu tlacitkum (zalezi na zapojeni klavesnice)
#DEFINE	TLAC_A	KEY,0
#DEFINE	TLAC_B	KEY,1
#DEFINE	TLAC_C	KEY,2
#DEFINE	TLAC_D	KEY,3
#DEFINE	TLAC_3	KEY,4
#DEFINE	TLAC_6	KEY,5
#DEFINE	TLAC_9	KEY,6
#DEFINE	TLAC_MR	KEY,7	; mrizka
#DEFINE	TLAC_2	KEY+1,0
#DEFINE	TLAC_5	KEY+1,1
#DEFINE	TLAC_8	KEY+1,2
#DEFINE	TLAC_0	KEY+1,3
#DEFINE	TLAC_1	KEY+1,4
#DEFINE	TLAC_4	KEY+1,5
#DEFINE	TLAC_7	KEY+1,6
#DEFINE	TLAC_HV	KEY+1,7	; hvezdicka

#DEFINE	SELECT_L	TLAC_7	; tlacitko "doleva"
#DEFINE	SELECT_P	TLAC_9	; tlacitko "doprava"
#DEFINE	SELECT_E	TLAC_MR	; tlacitko "vstup (enter) do podnabidky"
#DEFINE	SELECT_K	TLAC_HV	; tlacitko "konec podnabidky"

; definice skupiny parametru pro makro MENUX
#DEFINE	PARAM	HODNOTA, SELECT_P, SELECT_L, SELECT_E, SELECT_K

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

BUFF_SIZE	EQU	D'16'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TMH:1	; pro obsluhu displeje
	TML:1
	DDATA:1
	NUMFORM_:1
	AA:2
	BB:2
	CC:2
	VD16U:1
	HODNOTA:2

	KB:2
	KB2:4
	KBCITAC:1
	K_OUT:2
	KROK:1
	KEYTEMP:1
	K_STATUS:1
	S_KLAV:2
	K_CAS1:1
	K_CAS2:2
	KEY:2
	CITAC:1

	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	banksel	0
	
	; system klavesnice
	KEY_IPROG	INTCON, T0IF, PORTD, KB, KB2, KBCITAC, K_OUT, KROK, KEYTEMP, K_STATUS, S_KLAV, K_CAS1, K_CAS2, D'25', D'50', D'5', B'00001111'

INT_END	MOVF	FSR_TEMP,W
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE
	
START	
	banksel	OPTION_REG
	MOVLW	B'00000001'
	MOVWF	OPTION_REG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace displeje
	CALL	INITDISP

	; inicializace klavesnice
	KEY_INIT	INTCON, T0IE, T0IF, PORTD, KB, K_OUT, KROK, K_STATUS, K_CAS1, K_CAS2, S_KLAV

	BSF	INTCON,PEIE
	BSF	INTCON,GIE 

	MOVLW	D'0'	; spust uvodni skript
	CALL	SKRIPT
	CALL	READKEY	; cekej na stisknuti libovolne klavesy

	; uvodni nabidka
	; POZOR! - PARAM neni parametr, ale skupina parametru!!!
MENU0	MENUX	PARAM, PTACI_ - TABULKY + 1, PEVCI_ - TABULKY - 1, MENU0
	; odskoky na dalsi podnabidky
	BTFSC	STATUS,Z
	GOTO	MENU1
	DECF	HODNOTA,F
	BTFSC	STATUS,Z
	GOTO	MENU2
	GOTO	MENU3

	; podnabidka
MENU1	MENUX	PARAM, PEVCI_ - TABULKY + 1, DRAVCI_ - TABULKY - 1, MENU0
	; odskoky na hlubsi podnabidky
	BTFSC	STATUS,Z
	GOTO	MENU11
	DECF	HODNOTA,F
	BTFSC	STATUS,Z
	GOTO	MENU12
	DECF	HODNOTA,F
	BTFSC	STATUS,Z
	GOTO	MENU13
	GOTO	MENU14

	; a tak dale...

MENU2	MENUX	PARAM, DRAVCI_ - TABULKY + 1, VRUBOZOB_ - TABULKY - 1, MENU0
	BTFSC	STATUS,Z
	GOTO	MENU21
	DECF	HODNOTA,F
	BTFSC	STATUS,Z
	GOTO	MENU22
	GOTO	MENU23

MENU3	MENUX	PARAM, VRUBOZOB_ - TABULKY + 1, DROZDI_ - TABULKY - 1, MENU0
	BTFSC	STATUS,Z
	GOTO	MENU31
	DECF	HODNOTA,F
	BTFSC	STATUS,Z
	GOTO	MENU32
	GOTO	MENU33

MENU11	MENUX	PARAM, DROZDI_ - TABULKY + 1, SYKORY_ - TABULKY - 1, MENU1
	GOTO	MENU11

MENU12	MENUX	PARAM, SYKORY_ - TABULKY + 1, STRNADI_ - TABULKY - 1, MENU1
	GOTO	MENU12

MENU13	MENUX	PARAM, STRNADI_ - TABULKY + 1, KONIPASI_ - TABULKY - 1, MENU1
	GOTO	MENU13

MENU14	MENUX	PARAM, KONIPASI_ - TABULKY + 1, KANE_ - TABULKY - 1, MENU1
	GOTO	MENU14

MENU21	MENUX	PARAM, KANE_ - TABULKY + 1, POSTOLKY_ - TABULKY - 1, MENU2
	GOTO	MENU21

MENU22	MENUX	PARAM, POSTOLKY_ - TABULKY + 1, MOTACI_ - TABULKY - 1, MENU2
	GOTO	MENU22

MENU23	MENUX	PARAM, MOTACI_ - TABULKY + 1, CIRKY_ - TABULKY - 1, MENU2
	GOTO	MENU23

MENU31	MENUX	PARAM, CIRKY_ - TABULKY + 1, POLACI_ - TABULKY - 1, MENU3
	GOTO	MENU31

MENU32	MENUX	PARAM, POLACI_ - TABULKY + 1, TURPANI_ - TABULKY - 1, MENU3
	GOTO	MENU32

MENU33	MENUX	PARAM, TURPANI_ - TABULKY + 1, TAB_END - TABULKY - 1, MENU3
	GOTO	MENU33

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

	; 16bitove deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U

	; cekani na klavesu
READKEY	READKEY_	K_STATUS, K_OUT, KEY
	RETURN

	; cteni klavesove pameti
GETKEY	GETKEY_	KEY,CITAC
	RETURN

	; provedeni skriptu
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN



	ORG	H'800'
	; indexacni tabulka
TABULKY	DATA	INFO	
PTACI_	DATA	PTACI
	DATA	PEVCI
	DATA	DRAVCI
	DATA	VRUBOZOBI
PEVCI_	DATA	_PEVCI
	DATA	DROZD
	DATA	SYKORA
	DATA	STRNAD
	DATA	KONIPAS
DRAVCI_	DATA	_DRAVCI
	DATA	KANE
	DATA	POSTOLKA
	DATA	MOTAK
VRUBOZOB_	DATA	_VRUBOZOB
	DATA	CIRKA
	DATA	POLAK
	DATA	TURPAN
DROZDI_	DATA	_DROZDI
	DATA	ZPEVNY
	DATA	KVICALA
	DATA	K_CERNY
	DATA	K_HORSKY
SYKORY_	DATA	_SYKORY
	DATA	KONADRA
	DATA	MODRINKA
	DATA	BABKA
	DATA	PARUKARKA
	DATA	UHELNICEK
	DATA	LUZNI
STRNADI_	DATA	_STRNADI
	DATA	OBECNY
	DATA	LUCNI
	DATA	RAKOSNI
KONIPASI_	DATA	_KONIPASI
	DATA	BILY
	DATA	HORSKY
	DATA	LUCNI2
KANE_	DATA	_KANE
	DATA	LESNI
	DATA	ROUSNA
POSTOLKY_	DATA	_POSTOLKY
	DATA	OBECNA
	DATA	RUDONOHA
MOTACI_	DATA	_MOTACI
	DATA	LUZNI3
	DATA	PILICH
	DATA	POCHOP
CIRKY_	DATA	_CIRKY
	DATA	OBECNA2
	DATA	MODRA
POLACI_	DATA	_POLACI
	DATA	VELKY
	DATA	MALY
	DATA	CHOCHOL
TURPANI_	DATA	_TURPANI
	DATA	HNEDY
	DATA	CERNY
TAB_END

	; jednotlive skripty
	; (vyraz \X00 (a podobne) znamena znak s kodem 00 (nebo jinym))
INFO	DRESET
	ZNAK_RVH	D'0'	; definice velkeho "R" s hackem
	ZNAK_AVC	D'1'	; definice velkeho "A" s carkou
	POS_D	D'0'
	DE	"7/9 =P\X00ED./N\X01SL."
	POS_D	D'64'
	DE	"#/* =VSTUP/VYST."
	EOFS
	; a tak dale...
PTACI	DRESET
	ZNAK_AVC	D'0'
	POS_D	D'0'
	DE	"PT\X00CI (LETCI):"
	EOFS
PEVCI	ZNAK_EMH	D'1'
	POS_D	D'64'
	DE	"1) p\X01vci"
	DBLOK	' ',D'16'
	EOFS
DRAVCI	POS_D	D'64'
	DE	"2) dravci"
	DBLOK	' ',D'16'
	EOFS
VRUBOZOBI	ZNAK_IMC	D'1'
	POS_D	D'64'
	DE	"3) vrubozob\X01"
	DBLOK	' ',D'16'
	EOFS
_PEVCI	DRESET
	ZNAK_EVH	D'0'
	POS_D	D'0'
	DE	"P\X00VCI:"
	EOFS
DROZD	POS_D	D'64'
	DE	"1) drozdi"
	DBLOK	' ',D'16'
	EOFS
SYKORA	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"2) s\X01kory"
	DBLOK	' ',D'16'
	EOFS
STRNAD	POS_D	D'64'
	DE	"3) strnadi"
	DBLOK	' ',D'16'
	EOFS
KONIPAS	POS_D	D'64'
	DE	"4) konipasi"
	DBLOK	' ',D'16'
	EOFS
_DRAVCI	DRESET
	DE	"DRAVCI:"
	EOFS
KANE	ZNAK_AMC	D'0'
	ZNAK_EMH	D'1'
	POS_D	D'64'
	DE	"1) k\X00n\X01"
	DBLOK	' ',D'16'
	EOFS
POSTOLKA	ZNAK_SMH	D'0'
	POS_D	D'64'
	DE	"2) po\X00tolky"
	DBLOK	' ',D'16'
	EOFS
MOTAK	ZNAK_AMC	D'0'
	POS_D	D'64'
	DE	"3) mot\X00ci"
	DBLOK	' ',D'16'
	EOFS
_VRUBOZOB	DRESET
	ZNAK_IVC	D'0'
	POS_D	D'0'
	DE	"VRUBOZOB\X00:"
	EOFS
CIRKA	ZNAK_CMH	D'1'
	ZNAK_IMC	D'2'
	POS_D	D'64'
	DE	"1) \X01\X02rky"
	DBLOK	' ',D'16'
	EOFS
POLAK	ZNAK_AMC	D'1'
	POS_D	D'64'
	DE	"2) pol\X01ci"
	DBLOK	' ',D'16'
	EOFS
TURPAN	POS_D	D'64'
	DE	"3) turpani"
	DBLOK	' ',D'16'
	EOFS
_DROZDI	DRESET
	DE	"DROZDI:"
	EOFS
ZPEVNY	ZNAK_EMH	D'0'
	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"1) zp\X00vn\X01"
	DBLOK	' ',D'16'
	EOFS
KVICALA	ZNAK_IMC	D'0'
	ZNAK_CMH	D'1'
	POS_D	D'64'
	DE	"2) kv\X00\X01ala"
	DBLOK	' ',D'16'
	EOFS
K_CERNY	ZNAK_CMH	D'0'
	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"3) kos \X00ern\X01"
	DBLOK	' ',D'16'
	EOFS
K_HORSKY	ZNAK_YMC	D'0'
	POS_D	D'64'
	DE	"4) kos horsk\X00"
	DBLOK	' ',D'16'
	EOFS
_SYKORY	DRESET
	ZNAK_YVC	D'0'
	POS_D	D'0'
	DE	"S\X00KORY:"
	EOFS
KONADRA	ZNAK_NMH	D'1'
	POS_D	D'64'
	DE	"1) ko\X01adra"
	DBLOK	' ',D'16'
	EOFS
MODRINKA	ZNAK_RMH	D'1'
	POS_D	D'64'
	DE	"2) mod\X01inka"
	DBLOK	' ',D'16'
	EOFS
BABKA	POS_D	D'64'
	DE	"3) babka"
	DBLOK	' ',D'16'
	EOFS
PARUKARKA	ZNAK_AMC	D'1'
	ZNAK_RMH	D'2'
	POS_D	D'64'
	DE	"4) paruk\X01\X02ka"
	DBLOK	' ',D'16'
	EOFS
UHELNICEK	ZNAK_IMC	D'1'
	ZNAK_CMH	D'2'
	POS_D	D'64'
	DE	"5) uheln\X01\X02ek"
	DBLOK	' ',D'16'
	EOFS
LUZNI	ZNAK_ZMH	D'1'
	ZNAK_IMC	D'2'
	POS_D	D'64'
	DE	"6) lu\X01n\X02"
	DBLOK	' ',D'16'
	EOFS
_STRNADI	DRESET
	DE	"STRNADI:"
	EOFS
OBECNY	ZNAK_YMC	D'0'
	POS_D	D'64'
	DE	"1) obecn\X00"
	DBLOK	' ',D'16'
	EOFS
LUCNI	ZNAK_CMH	D'0'
	ZNAK_IMC	D'1'
	POS_D	D'64'
	DE	"2) lu\X00n\X01"
	DBLOK	' ',D'16'
	EOFS
RAKOSNI	ZNAK_AMC	D'0'
	ZNAK_IMC	D'1'
	POS_D	D'64'
	DE	"3) r\X00kosn\X01"
	DBLOK	' ',D'16'
	EOFS
_KONIPASI	DRESET
	DE	"KONIPASI:"
	EOFS
BILY	ZNAK_IMC	D'0'
	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"1) b\X00l\X01"
	DBLOK	' ',D'16'
	EOFS
HORSKY	ZNAK_YMC	D'0'
	POS_D	D'64'
	DE	"2) horsk\X00"
	DBLOK	' ',D'16'
	EOFS
LUCNI2	ZNAK_CMH	D'0'
	ZNAK_IMC	D'1'
	POS_D	D'64'
	DE	"2) lu\X00n\X01"
	DBLOK	' ',D'16'
	EOFS
_KANE	DRESET
	ZNAK_AVC	D'0'
	ZNAK_EVH	D'1'
	POS_D	D'0'
	DE	"K\X00N\X01:"
	EOFS
LESNI	ZNAK_IMC	D'2'
	POS_D	D'64'
	DE	"1) lesn\X02"
	DBLOK	' ',D'16'
	EOFS
ROUSNA	ZNAK_AMC	D'2'
	POS_D	D'64'
	DE	"2) rousn\X02"
	DBLOK	' ',D'16'
	EOFS
_POSTOLKY	DRESET
	ZNAK_SVH	D'0'
	POS_D	D'0'
	DE	"PO\X00TOLKY:"
	EOFS
OBECNA	ZNAK_AMC	D'1'
	POS_D	D'64'
	DE	"1) obecn\X01"
	DBLOK	' ',D'16'
	EOFS
RUDONOHA	ZNAK_AMC	D'1'
	POS_D	D'64'
	DE	"2) rudonoh\X01"
	DBLOK	' ',D'16'
	EOFS
_MOTACI	DRESET
	ZNAK_AVC	D'0'
	POS_D	D'0'
	DE	"MOT\X00CI:"
	EOFS
LUZNI3	ZNAK_ZMH	D'1'
	ZNAK_IMC	D'2'
	POS_D	D'64'
	DE	"1) lu\X01n\X02"
	DBLOK	' ',D'16'
	EOFS
PILICH	POS_D	D'64'
	DE	"2) pilich"
	DBLOK	' ',D'16'
	EOFS
POCHOP	POS_D	D'64'
	DE	"3) pochop"
	EOFS
_CIRKY	DRESET
	ZNAK_CVH	D'0'
	ZNAK_IVC	D'1'
	POS_D	D'0'
	DE	"\X00\X01RKY:"
	EOFS
OBECNA2	ZNAK_AMC	D'2'
	POS_D	D'64'
	DE	"1) obecn\X02"
	DBLOK	' ',D'16'
	EOFS
MODRA	ZNAK_AMC	D'2'
	POS_D	D'64'
	DE	"2) modr\X02"
	DBLOK	' ',D'16'
	EOFS
_POLACI	DRESET
	ZNAK_AVC	D'0'
	POS_D	D'0'
	DE	"POL\X00CI:"
	EOFS
VELKY	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"1) velk\X01"
	DBLOK	' ',D'16'
	EOFS
MALY	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"2) mal\X01"
	DBLOK	' ',D'16'
	EOFS
CHOCHOL	ZNAK_CMH	D'1'
	POS_D	D'64'
	DE	"3) chochola\X01ka"
	DBLOK	' ',D'16'
	EOFS
_TURPANI	DRESET
	DE	"TURPANI:"
	EOFS
HNEDY	ZNAK_EMH	D'0'
	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"1) hn\X00d\X01"
	DBLOK	' ',D'16'
	EOFS
CERNY	ZNAK_CMH	D'0'
	ZNAK_YMC	D'1'
	POS_D	D'64'
	DE	"2) \X00ern\X01"
	DBLOK	' ',D'16'
	EOFS

	END
